- name: create key
  community.crypto.openssl_privatekey:
    path: "{{ selfsigned_cert_directory }}/{{ selfsigned_cert_server_name }}.key"
    size: 2048
    mode: 0400

- name: Create certificate signing request (CSR) for self-signed certificate
  community.crypto.openssl_csr_pipe:
    privatekey_path: "{{ selfsigned_cert_directory }}/{{ selfsigned_cert_server_name }}.key"
    common_name: "{{ selfsigned_cert_server_name }}"
    organization_name: "{{ selfsigned_cert_org_name }}"
    subject_alt_name: "{{ selfsigned_cert_alt_names | default([]) }}"
  register: csr

- name: Create self-signed certificate from CSR
  community.crypto.x509_certificate:
    path: "{{ selfsigned_cert_directory }}/{{selfsigned_cert_server_name}}.crt"
    csr_content: "{{ csr.csr }}"
    privatekey_path: "{{ selfsigned_cert_directory }}/{{ selfsigned_cert_server_name }}.key"
    provider: selfsigned
  
